function [out1,out2]=updatesol(puzzle,sol)
x=puzzle; len=length(puzzle);
%CLEARING SOLUTION STRUCTURE
for h=1:length(x)
    sol(h).match=[];
    if isempty(puzzle(h).edge)==0
        for i=1:length(puzzle(h).edge(:,1))
            sol(h).edge{i,1}=zeros(1,2);
            sol(h).edge{i,2}=zeros(1,2);
        end
    end
end
%COMPILING SOLUTION MATRIX BASED ON SOLVED PIECES
for h=1:len
    if isempty(puzzle(h).edge)==0
        for i=1:length(puzzle(h).edge(:,1))
            for j=1:len
                hit=0;
                if h==j
                    continue
                end
                for k=1:length(puzzle(j).edge(:,1))
                    dist=HausdorffDist(puzzle(j).edge{k,1},puzzle(h).edge{i,1});
                    if dist<0.3
                        sol(h).edge{i,1}(1,1)=h; sol(h).edge{i,1}(1,2)=i;
                        sol(h).edge{i,2}(1,1)=j; sol(h).edge{i,2}(1,2)=k;
                        sol(j).edge{k,1}(1,1)=j; sol(j).edge{k,1}(1,2)=k;
                        sol(j).edge{k,2}(1,1)=h; sol(j).edge{k,2}(1,2)=i;
                        spot=length(sol(h).match)+1; here=length(sol(j).match)+1;
                        sol(h).match(spot)=j; sol(j).match(here)=h;
                        sol(h).match=sort(sol(h).match); sol(j).match=sort(sol(j).match);
                        hit=1;
                        break
                    end
                end
                if hit==1
                    break
                end
            end
        end
    end
end
%SIPHONING MATCH STRUCTURE
for h=1:len
    sol(h).match=sort(sol(h).match);
    for i=length(sol(h).match):-1:2
        if sol(h).match(i)==sol(h).match(i-1)
            sol(h).match(i)=[];
        end
    end
end
out1=puzzle; out2=sol;
end