%INPUT: DISCRETIZED EDGE

%THIS PROGRAM CALCULATES THE APPROXIMATE NORMAL VECTOR OF EACH POINT ON THE
%EDGE


function normalMatrix = ComputeNormals(edge)

normalMatrix = zeros(length(edge(:,1))-2,1);
for i=2:length(edge)-1
    normalMatrix(i,1:3) = cross(edge(i,:)-edge(i-1,:),edge(i,:)-edge(i+1)); 
end

end