function PlotSegments(puzzle,index)

%PLOTTING PUZZLE PIECE
figure(5); hold on

plot3(puzzle(index).piece(:,1),puzzle(index).piece(:,2),puzzle(index).piece(:,3))

for i=1:length(puzzle(index).edge(:,1))
    if mod(i,2)
        plot3(puzzle(index).edge{i,1}(:,1),puzzle(index).edge{i,1}(:,2),puzzle(index).edge{i,1}(:,3),'.r');
    else
        plot3(puzzle(index).edge{i,1}(:,1),puzzle(index).edge{i,1}(:,2),puzzle(index).edge{i,1}(:,3),'.g');       
    end
end

%PLOTTING SIGNATURE CURVE
figure(2); hold on

plot3(puzzle(index).sig(:,1),puzzle(index).sig(:,2),puzzle(index).sig(:,3))

for i=1:length(puzzle(index).edge(:,1))
   plot3(puzzle(index).edge{i,2}(:,1),puzzle(index).edge{i,2}(:,2),puzzle(index).edge{i,2}(:,3),'r','LineWidth',4); 
end

end
%%